<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.7.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html">DCFDelegateInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_d_c_f_delegate_interface_8h_source.html">DCFDelegateInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html" title="alexaClientSDK::dcfDelegate\l::DCFDelegate" alt="" coords="33,95,226,136"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a4b9cafef84c24229071ad800be399c53"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53">DCFPublishReturnCode</a> { <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53ad0749aaba8b833466dfcbb0428e4f89c">DCFPublishReturnCode::SUCCESS</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53ac6179cb17067a08588ff65efb6d02cdd">DCFPublishReturnCode::FATAL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53a338d7999ce17b46e8aff3f23d0436b06">DCFPublishReturnCode::RETRIABLE_ERROR</a>
 }</td></tr>
<tr class="separator:a4b9cafef84c24229071ad800be399c53"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2530eb5035dd616de228bba04ee0398f"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a2530eb5035dd616de228bba04ee0398f">~DCFDelegateInterface</a> ()=default</td></tr>
<tr class="separator:a2530eb5035dd616de228bba04ee0398f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92dfb2c329ee66e8d51dbc5e8d3f3c36"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a92dfb2c329ee66e8d51dbc5e8d3f3c36">registerCapability</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a> &gt; &amp;capability)=0</td></tr>
<tr class="separator:a92dfb2c329ee66e8d51dbc5e8d3f3c36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74b35eb6255f8238e146fa1f521f820b"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53">DCFPublishReturnCode</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a74b35eb6255f8238e146fa1f521f820b">publishCapabilities</a> ()=0</td></tr>
<tr class="separator:a74b35eb6255f8238e146fa1f521f820b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a865e7613191179cce82720687701b7c1"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a865e7613191179cce82720687701b7c1">publishCapabilitiesAsyncWithRetries</a> ()=0</td></tr>
<tr class="separator:a865e7613191179cce82720687701b7c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afce7394961bc822a7cb0d0aed3b3637e"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#afce7394961bc822a7cb0d0aed3b3637e">addDCFObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html">avsCommon::sdkInterfaces::DCFObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:afce7394961bc822a7cb0d0aed3b3637e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a496bb17bbd53881a8c57bb0be737664f"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a496bb17bbd53881a8c57bb0be737664f">removeDCFObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html">avsCommon::sdkInterfaces::DCFObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:a496bb17bbd53881a8c57bb0be737664f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class=""><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html">DCFDelegateInterface</a> is an interface with methods that provide clients a way to register capabilities implemented by agents and publish them so that Alexa is aware of the device's capabilities. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="a4b9cafef84c24229071ad800be399c53"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4b9cafef84c24229071ad800be399c53">&#9670;&nbsp;</a></span>DCFPublishReturnCode</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53">alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::DCFPublishReturnCode</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a4b9cafef84c24229071ad800be399c53ad0749aaba8b833466dfcbb0428e4f89c"></a>SUCCESS&#160;</td><td class="fielddoc"><p class="">The DCF publish message went through without issues. </p>
</td></tr>
<tr><td class="fieldname"><a id="a4b9cafef84c24229071ad800be399c53ac6179cb17067a08588ff65efb6d02cdd"></a>FATAL_ERROR&#160;</td><td class="fielddoc"><p class="">The message did not go through because of issues that need fixing. </p>
</td></tr>
<tr><td class="fieldname"><a id="a4b9cafef84c24229071ad800be399c53a338d7999ce17b46e8aff3f23d0436b06"></a>RETRIABLE_ERROR&#160;</td><td class="fielddoc"><p class="">The message did not go through, but you can retry to see if you succeed. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a2530eb5035dd616de228bba04ee0398f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2530eb5035dd616de228bba04ee0398f">&#9670;&nbsp;</a></span>~DCFDelegateInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::~DCFDelegateInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="afce7394961bc822a7cb0d0aed3b3637e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afce7394961bc822a7cb0d0aed3b3637e">&#9670;&nbsp;</a></span>addDCFObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::addDCFObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html">avsCommon::sdkInterfaces::DCFObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Specify an object to observe changes to the state of this DCFDelegate. During the call to this setter the observers onDCFStateChange() method will be called back with the current DCF state.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The object to observe the state of this DCFDelegate. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html#ac1306257dad56e1d4cceb8a550f57049">alexaClientSDK::dcfDelegate::DCFDelegate</a>.</p>

</div>
</div>
<a id="a74b35eb6255f8238e146fa1f521f820b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74b35eb6255f8238e146fa1f521f820b">&#9670;&nbsp;</a></span>publishCapabilities()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_delegate_interface.html#a4b9cafef84c24229071ad800be399c53">DCFPublishReturnCode</a> alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::publishCapabilities </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Publishes device capabilities that were registered. This function actually sends out a message to the DCF endpoint.</p>
<dl class="section return"><dt>Returns</dt><dd>A return code (DCFPublishReturnCode enum value) detailing the outcome of the publish message. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html#a2d2cf9415419372b76c4f773ed15b1a9">alexaClientSDK::dcfDelegate::DCFDelegate</a>.</p>

</div>
</div>
<a id="a865e7613191179cce82720687701b7c1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a865e7613191179cce82720687701b7c1">&#9670;&nbsp;</a></span>publishCapabilitiesAsyncWithRetries()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::publishCapabilitiesAsyncWithRetries </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Publishes capabilities asynchronously and will keep on retrying till it succeeds or there is a fatal error. </p>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html#ac2bcd1e4891408afa21fe0e394134cf1">alexaClientSDK::dcfDelegate::DCFDelegate</a>.</p>

</div>
</div>
<a id="a92dfb2c329ee66e8d51dbc5e8d3f3c36"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a92dfb2c329ee66e8d51dbc5e8d3f3c36">&#9670;&nbsp;</a></span>registerCapability()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::registerCapability </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>capability</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Registers device capabilities that a component is implementing. This only updates a local registry and does not actually send out a message to the DCF endpoint.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">capability</td><td>The capability configuration which houses the capabilities being implemented. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if registering was successful, else false. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html#ab519b7e5f15c35ae5c4a0858842b0716">alexaClientSDK::dcfDelegate::DCFDelegate</a>.</p>

</div>
</div>
<a id="a496bb17bbd53881a8c57bb0be737664f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a496bb17bbd53881a8c57bb0be737664f">&#9670;&nbsp;</a></span>removeDCFObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DCFDelegateInterface::removeDCFObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html">avsCommon::sdkInterfaces::DCFObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove an observer</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to remove. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1dcf_delegate_1_1_d_c_f_delegate.html#abec18bcce5fda131efb6e2fff5507e34">alexaClientSDK::dcfDelegate::DCFDelegate</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/release/tools/avs-cpp-sdk-tools/cm/output2/autoCM_publicRepo/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_d_c_f_delegate_interface_8h_source.html">DCFDelegateInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.7.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
